package org.omg.CosNaming;

import java.io.ObjectOutputStream;
import java.io.IOException;
import org.omg.CORBA.ORB;
import java.io.ObjectInputStream;
import org.omg.CORBA.portable.OutputStream;
import org.omg.CORBA.portable.InputStream;
import org.omg.CORBA.portable.RemarshalException;
import org.omg.CORBA.portable.ApplicationException;
import org.omg.CORBA.MARSHAL;
import org.omg.CORBA.portable.ObjectImpl;

public class _BindingIteratorStub extends ObjectImpl implements BindingIterator
{
    private static String[] __ids;
    
    public _BindingIteratorStub() {
    }
    
    public boolean next_one(BindingHolder bindingHolder) {
        InputStream inputStream = null;
        try {
            inputStream = this._invoke(this._request("next_one", true));
            int read_boolean = inputStream.read_boolean();
            bindingHolder.value = BindingHelper.read(inputStream);
            return read_boolean;
        }
        catch (ApplicationException ex) {
            inputStream = ex.getInputStream();
            throw new MARSHAL(ex.getId());
        }
        catch (RemarshalException ex2) {
            return this.next_one(bindingHolder);
        }
        finally {
            this._releaseReply(inputStream);
        }
    }
    
    public boolean next_n(int n, BindingListHolder bindingListHolder) {
        InputStream inputStream = null;
        try {
            OutputStream request = this._request("next_n", true);
            request.write_ulong(n);
            inputStream = this._invoke(request);
            int read_boolean = inputStream.read_boolean();
            bindingListHolder.value = BindingListHelper.read(inputStream);
            return read_boolean;
        }
        catch (ApplicationException ex) {
            inputStream = ex.getInputStream();
            throw new MARSHAL(ex.getId());
        }
        catch (RemarshalException ex2) {
            return this.next_n(n, bindingListHolder);
        }
        finally {
            this._releaseReply(inputStream);
        }
    }
    
    public void destroy() {
        InputStream inputStream = null;
        try {
            inputStream = this._invoke(this._request("destroy", true));
            return;
        }
        catch (ApplicationException ex) {
            inputStream = ex.getInputStream();
            throw new MARSHAL(ex.getId());
        }
        catch (RemarshalException ex2) {
            this.destroy();
        }
        finally {
            this._releaseReply(inputStream);
        }
    }
    
    public String[] _ids() {
        return (String[])(String[])_BindingIteratorStub.__ids.clone();
    }
    
    private void readObject(ObjectInputStream objectInputStream) throws IOException {
        String utf = objectInputStream.readUTF();
        ORB init = ORB.init(null, null);
        try {
            this._set_delegate(((ObjectImpl)init.string_to_object(utf))._get_delegate());
        }
        finally {
            init.destroy();
        }
    }
    
    private void writeObject(ObjectOutputStream objectOutputStream) throws IOException {
        ORB init = ORB.init(null, null);
        try {
            objectOutputStream.writeUTF(init.object_to_string(this));
        }
        finally {
            init.destroy();
        }
    }
    
    static {
        _BindingIteratorStub.__ids = new String[] { "IDL:omg.org/CosNaming/BindingIterator:1.0" };
    }
}
